#include <cmath>
#include <cstdlib>
#include <iostream>

using namespace std;

double pol(double x)
{
	return ((5*x + 4)*x - 2)*x +1;
}

double biseccion(double (*f)(double), double a, double b, double tol)
{
	double m;
	bool sgn= f(a) >= 0.0;
	do {
		m= a + 0.5*(b-a);
		if ( (f(m)>=0.0) == sgn )
			a= m;
		else
			b= m;
	} while ( b-a >= tol );
	return m;
}

int main(int argc, char *argv[])
{
	double raiz=  biseccion( pol, -2.0, 2.0, 1E-9 );
	cout << "p(raiz)= " << pol(raiz) << endl;
	cout << "raiz= " << raiz << endl;

	raiz= biseccion(sin, 3.0, 4.0, 1E-9);
	cout << "sin(raiz)= " << sin(raiz) << endl;
	cout << "raiz= " << raiz << endl;
	
	return EXIT_SUCCESS;
}
